(function () {
"use strict";
const {Cc: classes, Ci: interfaces, Cu: utils} = Components;
var core = Cc["@yandex.ru/vb-core;1"].getService().wrappedJSObject;
var app = core.application;
if (app === null)
return;
const kBrowserMajorVersion = parseFloat(app.core.Lib.sysutils.platformInfo.browser.version,10);
const OS_NAME = app.core.Lib.sysutils.platformInfo.os.name;
const FTAB_URL = app.protocolSupport.url;
const XUL_NS = "http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul";
const PRELOAD_CHROME_URL = "chrome://yandex-vb/content/overlay/hiddenwindow.xul";
const PRELOADER_INIT_DELAY_MS = 5000;
var browserNewTabURL = kBrowserMajorVersion >= 12 ? BROWSER_NEW_TAB_URL : core.Lib.Preferences.get("browser.newtab.url");
var originalBrowserOpenTabFn = kBrowserMajorVersion >= 12 ? window.BrowserOpenTab : window.openUILinkIn.bind(window,browserNewTabURL,"tab");
var keysPressed = [];
var onShortcutPressed = function () {
var thumbIndex = 0;
for (let i = 0;i < keysPressed.length;i++) {
let exponent = keysPressed.length - i - 1;
thumbIndex += keysPressed[i] * Math.pow(10,exponent);
}

app.fastdial.onShortcutPressed(thumbIndex - 1);
app.fastdial.sendRequest("modifierPressed",{
pressed: false});
keysPressed.length = 0;
}
;
var lastKeyCodePressed;
var shortCutListener = function shortCutListener(evt) {
if (gBrowser.selectedBrowser.currentURI.spec !== FTAB_URL)
return;
if (OS_NAME === "windows")
{
if (windowsShortCutListener(evt))
evt.preventDefault();
return;
}

var isNumberCode = evt.keyCode >= 48 && evt.keyCode <= 57;
var isModifierAlsoPressed = evt.ctrlKey && OS_NAME === "linux" || evt.altKey && OS_NAME !== "linux";
var isModifierPressedOnly = evt.keyCode === evt.DOM_VK_CONTROL && OS_NAME === "linux" || evt.keyCode === evt.DOM_VK_ALT && OS_NAME !== "linux";
var thumbIndex;
switch (evt.type) {
case "keydown":
if (! isNumberCode)
app.fastdial.sendRequest("modifierPressed",{
pressed: isModifierPressedOnly});
if (lastKeyCodePressed && lastKeyCodePressed === evt.keyCode)
{
evt.preventDefault();
return;
}

if (! isModifierAlsoPressed || ! isNumberCode || evt.keyCode === evt.DOM_VK_0 && ! keysPressed.length)
return;
thumbIndex = evt.keyCode - 48;
keysPressed.push(thumbIndex);
lastKeyCodePressed = evt.keyCode;
break;
case "keyup":
if (! keysPressed.length)
{
app.fastdial.sendRequest("modifierPressed",{
pressed: false});
return;
}

if (lastKeyCodePressed === evt.keyCode)
lastKeyCodePressed = null;
let isControlKeyPressed = OS_NAME === "linux" && evt.keyCode === evt.DOM_VK_CONTROL || OS_NAME !== "linux" && evt.keyCode === evt.DOM_VK_ALT;
if (! isControlKeyPressed)
return;
onShortcutPressed();
break;
}

evt.preventDefault();
}
;
var keyPressedTimeoutId;
var windowsShortCutListener = function (evt) {
var [evtType, keyCode, altKeyPressed] = [evt.type, evt.keyCode, evt.altKey];
var isNumberCode = keyCode >= 48 && keyCode <= 57;
switch (evtType) {
case "keydown":
if (! isNumberCode)
{
app.fastdial.sendRequest("modifierPressed",{
pressed: keyCode === evt.DOM_VK_ALT});
return false;
}

if (! altKeyPressed)
return false;
if (lastKeyCodePressed && lastKeyCodePressed === keyCode)
return false;
if (keyCode === 48 && ! keysPressed.length)
return false;
app.fastdial.sendRequest("modifierPressed",{
pressed: true});
let thumbIndex = keyCode - 48;
keysPressed.push(thumbIndex);
lastKeyCodePressed = keyCode;
if (keyPressedTimeoutId)
window.clearTimeout(keyPressedTimeoutId);
break;
case "keyup":
if (! isNumberCode)
{
if (keyCode === evt.DOM_VK_ALT)
app.fastdial.sendRequest("modifierPressed",{
pressed: false});
return false;
}

if (lastKeyCodePressed === keyCode)
{
lastKeyCodePressed = null;
app.fastdial.sendRequest("modifierPressed",{
pressed: false});
if (keysPressed.length === 1 && app.layout.getThumbsNum() < 10)
return onShortcutPressed();
keyPressedTimeoutId = window.setTimeout(onShortcutPressed,500);
}

break;
}

return true;
}
;
var NewHiddenTabManager = {
get tab() {
return ! this._tab || ! this._tab.contentDocument || this._tab.contentDocument.readyState !== "complete" ? null : this._tab;
}
,
init: function HiddenTabManager_init() {
var doc = app.core.Lib.misc.hiddenWindows.appWindow.document;
this._iframe = doc.createElement("iframe");
this._iframe.setAttribute("src",PRELOAD_CHROME_URL);
doc.documentElement.appendChild(this._iframe);
window.setTimeout(this.create.bind(this),PRELOADER_INIT_DELAY_MS);
var self = this;
window.BrowserOpenTab = function BrowserOpenTab() {
if (! self.tab)
{
originalBrowserOpenTabFn.call(window);
return;
}

app.fastdial.onHiddenTabAction("show");
var newTab = gBrowser.loadOneTab("about:blank",{
inBackground: false});
gBrowser.swapNewTabWithBrowser(newTab,self.tab);
window.focusAndSelectUrlBar();
self.create();
}
;
}
,
finalize: function HiddenTabManager_finalize() {
this._tab = null;
var doc = app.core.Lib.misc.hiddenWindows.appWindow.document;
doc.documentElement.removeChild(this._iframe);
this._iframe = null;
}
,
create: function HiddenTabManager_create() {
var contentWindow = this._iframe.contentWindow;
this._tab = contentWindow.document.createElementNS(XUL_NS,"browser");
this._tab.setAttribute("type","content");
this._tab.setAttribute("src",FTAB_URL);
contentWindow.document.documentElement.appendChild(this._tab);
app.fastdial.onHiddenTabAction("hide");
}
,
_tab: null,
_iframe: null};
var OldHiddenTabManager = {
init: function OldHiddenTabManager_init() {
var self = this;
window.BrowserOpenTab = function BrowserOpenTab() {
if (self._tab)
{
app.fastdial.onHiddenTabAction("show");
window.gBrowser.showTab(self._tab);
window.gBrowser.selectedTab = self._tab;
window.gBrowser.moveTabToEnd();
window.focusAndSelectUrlBar();
let tabViewChromeWindow = TabView.getContentWindow();
if (tabViewChromeWindow && tabViewChromeWindow.TabItems)
{
tabViewChromeWindow.TabItems.link(self._tab,{
immediately: true});
tabViewChromeWindow.TabItems.update(self._tab);
}

self._tab = null;
self._preloadTabTimeoutId = window.setTimeout(self._preloadTab.bind(self),100);
}
 else
{
try {
originalBrowserOpenTabFn();
}
catch (e) {

}

window.focusAndSelectUrlBar();
if (overlayController._preloadTabTimeoutId)
window.clearTimeout(overlayController._preloadTabTimeoutId);
overlayController._preloadTabTimeoutId = window.setTimeout(self._preloadTab.bind(self),100);
}

}
;
window.gBrowser.tabContainer.addEventListener("TabClose",this,false);
TabView._initFrame = (function () {
var initFrameOrig = TabView._initFrame;
var tabViewFrameInitialized = false;
var onTabReady = function () {
if (self._tab && self._tab._tabViewTabItem)
{
TabView.getContentWindow().TabItems.unlink(self._tab);
}

}
;
return function () {
initFrameOrig.apply(this,arguments);
if (tabViewFrameInitialized)
{
onTabReady();
}
 else
{
window.addEventListener("tabviewframeinitialized",function onTabViewFrameInit() {
window.removeEventListener("tabviewframeinitialized",onTabViewFrameInit);
tabViewFrameInitialized = true;
onTabReady();
}
);
}

}
;
}
)();
}
,
finalize: function OldHiddenTabManager_finalize() {
if (this._preloadTabTimeoutId)
window.clearTimeout(this._preloadTabTimeoutId);
window.gBrowser.tabContainer.removeEventListener("TabClose",this,false);
this._tab = null;
}
,
handleEvent: function OldHiddenTabManager__handleEvent(evt) {
switch (evt.type) {
case "TabClose":
if (window.gBrowser.visibleTabs.length > 1)
return;
if (this._tab)
{
window.gBrowser.removeTab(this._tab);
this._tab = null;
}

break;
}

}
,
_preloadTab: function OldHiddenTabManager__preloadTab() {
app.fastdial.onHiddenTabAction("hide");
this._tab = window.gBrowser.loadOneTab(browserNewTabURL,{
inBackground: true});
window.gBrowser.hideTab(this._tab);
this._preloadTabTimeoutId = null;
}
,
_tab: null,
_preloadTabTimeoutId: null};
var overlayController = {
init: function OverlayController_init() {
window.gInitialPages.push(FTAB_URL);
this._setBeginRemoveTab();
this._setBoostOpenTab();
this._setBrowserOpenTab();
this._windowListener = new app.core.Lib.WindowListener(window, app.name, app.getLogger("WindowListener"));
this._windowListener.addListener("WindowLocationChange",this);
gURLBar.addEventListener("keydown",shortCutListener,false);
gURLBar.addEventListener("keyup",shortCutListener,false);
gBrowser.tabContainer.addEventListener("TabOpen",this,false);
gBrowser.tabContainer.addEventListener("TabClose",this,false);
if (app.installer.anonymousStatistic)
{
this.askAnonymousStatistic();
}

}
,
finalize: function OverlayController_finalize() {
this._windowListener.removeListener("WindowLocationChange",this);
this._windowListenerData = {
};
gBrowser.tabContainer.removeEventListener("TabClose",this,false);
gBrowser.tabContainer.removeEventListener("TabOpen",this,false);
gURLBar.removeEventListener("keydown",shortCutListener,false);
gURLBar.removeEventListener("keyup",shortCutListener,false);
}
,
handleEvent: function OverlayController_handleEvent(aEvent) {
var browser = gBrowser.getBrowserForTab(aEvent.target);
switch (aEvent.type) {
case "TabOpen":
browser.addEventListener("keydown",shortCutListener,false);
browser.addEventListener("keyup",shortCutListener,false);
break;
case "TabClose":
browser.removeEventListener("keydown",shortCutListener,false);
browser.removeEventListener("keyup",shortCutListener,false);
break;
}

}
,
askAnonymousStatistic: function WndCtrl_askAnonymousStatistic() {
(new AnonymousStatisticController(this, this._windowListener)).notify();
}
,
_setBoostOpenTab: function OverlayController__setBoostOpenTab() {
if (browserNewTabURL !== FTAB_URL)
return;
if (kBrowserMajorVersion >= 18)
{
NewHiddenTabManager.init();
}
 else
{
OldHiddenTabManager.init();
}

}
,
_setBrowserOpenTab: function OverlayController__setBrowserOpenTab() {
if (! this._cachedBrowserOpenTab)
{
this._cachedBrowserOpenTab = window.BrowserOpenTab;
}
 else
{
window.BrowserOpenTab = this._cachedBrowserOpenTab;
}

if (this._browserOpenTabTreshold < 10)
{
this._browserOpenTabTreshold++;
window.setTimeout(this._setBrowserOpenTab.bind(this),1000);
}
 else
{
this._cachedBrowserOpenTab = null;
}

;
}
,
_replaceBlankTab: function OverlayController__replaceBlankTab() {
var tabs = gBrowser.tabContainer.childNodes;
if (tabs.length !== 1)
{
return;
}

var browser = tabs[0].linkedBrowser;
if (! browser)
{
return;
}

var currentURI = browser.currentURI;
if (! currentURI || currentURI.spec != "about:blank")
{
return;
}

if (browser.webProgress.isLoadingDocument || browser.userTypedValue)
{
return;
}

var doc = browser.contentDocument;
if (! doc)
{
return;
}

var body = doc.body;
if (! body || body.hasChildNodes())
{
return;
}

browser.loadURI(FTAB_URL,null,null,false);
}
,
_setBeginRemoveTab: function OverlayController__setBeginRemoveTab() {
if (kBrowserMajorVersion >= 12)
return;
const browserCloseLastTabFnName = kBrowserMajorVersion < 6 ? "_endRemoveTab" : "_beginRemoveTab";
[browserCloseLastTabFnName].forEach(function (fnName) {
if (! (fnName in gBrowser))
{
Cu.reportError("There is no '" + fnName + "' in the gBrowser.");
return;
}

var origFnSource = gBrowser[fnName].toSource();
var ownSource = origFnSource.replace(/about:blank/g,FTAB_URL);
var ownFn = Function("return " + ownSource)();
ownFn.toSource = function () origFnSource;
gBrowser[fnName] = ownFn;
}
);
}
,
observe: function OverlayController_observe(aSubject, aTopic, aData) {
var win = aData.tab.contentWindow;
if (! win)
return;
var winURL = win.location.href;
var utils = win.QueryInterface(Ci.nsIInterfaceRequestor).getInterface(Ci.nsIDOMWindowUtils);
var outerWindowID = utils.outerWindowID;
this._windowListenerData[outerWindowID] = this._windowListenerData[outerWindowID] || winURL;
if (this._windowListenerData[outerWindowID] !== winURL)
{
if (this._windowListenerData[outerWindowID] === FTAB_URL)
app.fastdial.onTabLeave(outerWindowID);
if (winURL === FTAB_URL)
win.location.reload();
this._windowListenerData[outerWindowID] = winURL;
}

}
,
get windowListener() this._windowListener,
_browserOpenTabTreshold: 0,
_cachedBrowserOpenTab: null,
_preloadTabTimeoutId: null,
_hiddenTab: null,
_windowListenerData: {
}};
function AnonymousStatisticController(aOverlayController, aWindowListener) {
this._overlayController = aOverlayController;
this._logger = app.getLogger("AnonymousStatisticController");
this._windowListener = aWindowListener;
this._windowListener.addListener("PageShow",this);
}

AnonymousStatisticController.prototype = {
observe: function AnonStatCtrl_observe(aSubject, aTopic, aData) {
switch (aTopic) {
case "PageShow":
this._showAnonymousStatisticNotification();
break;
default:
break;
}

}
,
notify: function AnonStatCtrl_notify() {
core.Lib.misc.getBrowserWindows().forEach(function (win) {
var tabbrowser = win.gBrowser;
tabbrowser.browsers.forEach(function (browser, i) {
this._showAnonymousStatisticNotification(tabbrowser,browser);
}
,this);
}
,this);
}
,
_finalize: function AnonStatCtrl_finalize() {
this._windowListener.removeListener("PageShow",this);
this._overlayController = null;
this._logger = null;
this._windowListener = null;
}
,
_showAnonymousStatisticNotification: function AnonStatCtrl__showAnonymousStatisticNotification(aGBrowser, aBrowser) {
var tabbrowser = aGBrowser || gBrowser;
var notificationBox = tabbrowser.getNotificationBox(aBrowser);
var notification = notificationBox.getNotificationWithValue(this.ANONYMOUS_STATISTIC_NOTIFICATION);
if (notification)
return;
var stringBundle = new app.appStrings.StringBundle("notification/anonymous-statistic.properties");
var label = stringBundle.get("notification.label",[this.helpURL]);
var acceptButton = {
label: stringBundle.get("notification.accept"),
callback: this._enableAnonymousStatistic.bind(this),
accessKey: ""};
var rejectButton = {
label: stringBundle.get("notification.reject"),
callback: this._disableAnonymousStatistic.bind(this),
accessKey: ""};
notification = notificationBox.appendNotification(label,this.ANONYMOUS_STATISTIC_NOTIFICATION,null,notificationBox.PRIORITY_INFO_HIGH,[acceptButton, rejectButton],null);
notification.setAttribute("hideclose","true");
var link = notification.ownerDocument.createElementNS(XUL_NS,"label");
link.setAttribute("anonid","link");
link.setAttribute("value",stringBundle.get("notification.help"));
link.setAttribute("href",this.helpURL);
link.classList.add("text-link");
var description = notification.ownerDocument.getAnonymousElementByAttribute(notification,"anonid","messageText");
description.appendChild(link);
}
,
_closeAllAnonymousStatisticNotifications: function AnonStatCtrl__closeAllNotificationsStatisticNotifications() {
core.Lib.misc.getBrowserWindows().forEach(function (win) {
var tabbrowser = win.gBrowser;
tabbrowser.browsers.forEach(function (browser) {
var notificationBox = tabbrowser.getNotificationBox(browser);
var notification = notificationBox.getNotificationWithValue(this.ANONYMOUS_STATISTIC_NOTIFICATION);
if (notification)
notificationBox.removeNotification(notification);
}
,this);
}
,this);
}
,
_enableAnonymousStatistic: function AnonStatCtrl__enableAnonymousStatistic() {
this._onAnswerAnonymousStatistic(true);
}
,
_disableAnonymousStatistic: function AnonStatCtrl__disableAnonymousStatistic() {
this._onAnswerAnonymousStatistic(false);
}
,
_onAnswerAnonymousStatistic: function AnonStatCtrl__onAnswerAnonymousStatistic(aEnable) {
this._closeAllAnonymousStatisticNotifications();
app.installer.anonymousStatistic = aEnable;
this._finalize();
}
,
get helpURL() {
var domain = "legal.yandex.ru";
var postfix = "";
switch (app.branding.productInfo.BrandID.toString()) {
case "ua":
domain = "legal.yandex.ua";
break;
case "tb":
domain = "legal.yandex.com.tr";
break;
}

switch (app.locale.language) {
case "en":
postfix = "?lang=en";
break;
case "tr":
postfix = "?lang=en";
break;
case "uk":
postfix = "?lang=uk";
break;
}

return "http://" + domain + "/confidential/" + postfix;
}
,
get ANONYMOUS_STATISTIC_NOTIFICATION() {
return app.name + "-anonymous-statistic-notification";
}
};
var hidden, visibilityChange;
if (typeof document.hidden !== "undefined")
{
hidden = "hidden";
visibilityChange = "visibilitychange";
}
 else
if (typeof document.mozHidden !== "undefined")
{
hidden = "mozHidden";
visibilityChange = "mozvisibilitychange";
}

if (visibilityChange !== undefined)
{
window.addEventListener(visibilityChange,function (evt) {
if (evt.target.location.href === FTAB_URL && evt.target[hidden])
app.fastdial.sendRequest("modifierPressed",{
pressed: false});
if (evt.target[hidden] === false && evt.target.location.href === FTAB_URL)
{
let win = gBrowser.getBrowserForTab(gBrowser.selectedTab).contentWindow;
if (! win)
return;
let utils = win.QueryInterface(Ci.nsIInterfaceRequestor).getInterface(Ci.nsIDOMWindowUtils);
let outerWindowID = utils.outerWindowID;
app.fastdial.onTabSelect(outerWindowID);
}

}
,false);
}

window.addEventListener("deactivate",function (evt) {
app.fastdial.sendRequest("modifierPressed",{
pressed: false});
}
,false);
window[app.name + "OverlayController"] = overlayController;
window.addEventListener("DOMContentLoaded",function onDOMContentLoaded() {
window.removeEventListener("DOMContentLoaded",onDOMContentLoaded,false);
overlayController.init();
window.addEventListener("unload",function unLoad() {
if (kBrowserMajorVersion >= 18)
{
NewHiddenTabManager.finalize();
}
 else
{
OldHiddenTabManager.finalize();
}

overlayController.finalize();
}
,false);
}
,false);
window.addEventListener("load",function onWindowLoaded() {
window.removeEventListener("load",onWindowLoaded,false);
setTimeout(function () overlayController._replaceBlankTab(),10);
}
,false);
}
)();
